"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _button = require("antd/es/button");

var _button2 = _interopRequireDefault(_button);

var _popover = require("antd/es/popover");

var _popover2 = _interopRequireDefault(_popover);

var _icon = require("antd/es/icon");

var _icon2 = _interopRequireDefault(_icon);

var _input = require("antd/es/input");

var _input2 = _interopRequireDefault(_input);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require("antd/es/button/style/css");

require("antd/es/popover/style/css");

require("antd/es/icon/style/css");

require("antd/es/input/style/css");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _constant = require("../../constant");

var _Upload = require("./Upload");

var _Upload2 = _interopRequireDefault(_Upload);

var _Emoji = require("./Emoji");

var _Emoji2 = _interopRequireDefault(_Emoji);

require("./index.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextArea = _input2.default.TextArea;
// 设置 Editor 组件的默认值
// 不能在 Editor.defaultProps 中设置
// 因为 Editor 在 ComponentInput 中调用
// 在 ComponentInput 中，需要使用 Editor 的 props 覆盖 ComponentInput 传入的 props

var EditorDefaultProps = {
  rows: 5,
  placeholder: "说点什么吧...",
  showEmoji: true,
  showUpload: true,
  submitText: "发表",
  onChange: function onChange() {}
};

var Editor = function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor(props) {
    _classCallCheck(this, Editor);

    var _this = _possibleConstructorReturn(this, (Editor.__proto__ || Object.getPrototypeOf(Editor)).call(this, props));

    _this.state = {
      showUpload: false
    };
    _this.handleClickEmoji = _this.handleClickEmoji.bind(_this);
    _this.handleShowUpload = _this.handleShowUpload.bind(_this);
    return _this;
  }

  _createClass(Editor, [{
    key: "componentDidMount",
    value: function componentDidMount() {}
  }, {
    key: "handleClickEmoji",
    value: function handleClickEmoji(emojiId) {
      this.props.onChangeEmoji(emojiId);
    }
  }, {
    key: "handleShowUpload",
    value: function handleShowUpload(showUpload) {
      if (typeof showUpload === "boolean") {
        this.setState({ showUpload: showUpload });
      } else {
        this.setState({ showUpload: !this.state.showUpload });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = _extends({}, EditorDefaultProps, this.props);
      var value = props.value,
          _onChange = props.onChange,
          onSubmit = props.onSubmit,
          loading = props.loading,
          placeholder = props.placeholder,
          fileList = props.fileList,
          onChangeFileList = props.onChangeFileList,
          rows = props.rows,
          onUpload = props.onUpload,
          showEmoji = props.showEmoji,
          showUpload = props.showUpload,
          submitText = props.submitText;


      return _react2.default.createElement(
        "div",
        { className: "editor" },
        _react2.default.createElement(TextArea, {
          value: value,
          onChange: function onChange(e) {
            return _onChange(e.target.value);
          },
          rows: rows,
          placeholder: placeholder
        }),
        _react2.default.createElement(
          "div",
          { className: "toolbar" },
          _react2.default.createElement(
            "div",
            { style: { float: "left", margin: "8px 11px" } },
            showEmoji && _react2.default.createElement(
              _popover2.default,
              {
                trigger: "click",
                placement: "bottomLeft",
                autoAdjustOverflow: false,
                content: _react2.default.createElement(
                  "div",
                  { style: { width: 200 } },
                  _react2.default.createElement(_Emoji2.default, { onClick: this.handleClickEmoji })
                ),
                overlayClassName: "feed"
              },
              _react2.default.createElement(_icon2.default, { type: "smile-o", className: "icon" })
            ),
            showUpload && _react2.default.createElement(
              _popover2.default,
              {
                visible: this.state.showUpload,
                overlayStyle: { zIndex: 999 },
                content: _react2.default.createElement(
                  "div",
                  {
                    style: { width: 112 * _constant.MAX_UPLOAD_NUMBER, minHeight: 100 }
                  },
                  _react2.default.createElement(_Upload2.default, {
                    onChangeFileList: onChangeFileList,
                    onUpload: onUpload,
                    fileList: fileList
                  })
                ),
                placement: "bottomLeft",
                title: _react2.default.createElement(
                  "div",
                  { style: { margin: "5px auto" } },
                  _react2.default.createElement(
                    "span",
                    null,
                    "\u4E0A\u4F20\u56FE\u7247",
                    _react2.default.createElement(
                      "span",
                      { style: { color: "#666", fontWeight: 400 } },
                      "(\u60A8\u8FD8\u80FD\u4E0A\u4F20",
                      _constant.MAX_UPLOAD_NUMBER - fileList.length,
                      "\u5F20\u56FE\u7247)"
                    )
                  ),
                  _react2.default.createElement(_icon2.default, {
                    type: "close",
                    onClick: function onClick() {
                      return _this2.handleShowUpload(false);
                    },
                    style: {
                      float: "right",
                      cursor: "pointer",
                      marginTop: 4
                    }
                  })
                )
              },
              _react2.default.createElement(_icon2.default, {
                type: "picture",
                className: "icon",
                style: { marginLeft: 10 },
                onClick: function onClick() {
                  return _this2.handleShowUpload(true);
                }
              })
            )
          ),
          _react2.default.createElement(
            "div",
            { style: { float: "right", margin: "5px 11px" } },
            _react2.default.createElement(
              _button2.default,
              { onClick: onSubmit, type: "primary", loading: loading },
              submitText
            )
          )
        )
      );
    }
  }]);

  return Editor;
}(_react2.default.Component);

Editor.propTypes = {
  rows: _propTypes2.default.number,
  placeholder: _propTypes2.default.string,
  showEmoji: _propTypes2.default.bool,
  showUpload: _propTypes2.default.bool,
  submitText: _propTypes2.default.string,
  onChange: _propTypes2.default.func
};

exports.default = Editor;
//# sourceMappingURL=index.js.map